#! /usr/bin/env python

from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 5.0, -5.0, 4.0 ), "color", vector3( 300.0, 300.0, 300.0 ) ] ) )

map = s.newPattern( "map",
		     [ "texture", s.newTexture( "../Textures/cornell.tga" ),
		       "orientation", 0, 0 ] )

s.transformBegin( transform().scaling( vector3( 3, 3, 3 ) ) )

envcube = s.newPattern( "envcube",
			[ "patterns", map, map, map, map, map, map,
			  "reflection", vector3( 1, 1, 1 ),
			  "refraction", vector3( 0, 0, 0 ),
			  "IOR", 15.0,
			  "fresnel", 1, 0.0, 0.0,
			  "orientation", 0, 0 ] )

s.transformEnd()

plastic = s.newMaterial( "generic",
			 [ "kdr", vector3( 0, 0, 0 ),
			   "ksr", vector3( 1, 1, 1 ),
			   "km", 0.1,
			   "IOR", 15.0,
			   "fresnel", 1, 0.0, 0.0,
			   "ka", vector3( 1, 1, 1 ),
			   "ka", envcube ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )
#s.addObject( s.newObject( "box", [ "position",
#				   vector3( -0.6, -0.6, -0.6 ), vector3( 0.6, 0.6, 0.6 ) ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "env.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -2, -3, 1 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
