#! /usr/bin/env python

from lightflowPM import *
from math import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 4.0, -5.0, 4.0 ), "color", vector3( 250.0, 250.0, 250.0 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3( -6.0, -3.0, -4.0 ), "color", vector3( 100.0, 0.0, 0.0 ) ] ) )


s.transformBegin( transform().rotationAroundZ( pi / 7 ) )
s.transformBegin( transform().rotationAroundX( pi / 6 ) )

granite1 = s.newPattern( "granite",
			 [ "color",
			   0.0, vector3( 0.9, 0.90, 1.00 ), vector3( 0.9, 0.90, 1.00 ),
			   0.2, vector3( 1.0, 1.00, 1.00 ), vector3( 1.0, 1.00, 1.00 ),
			   0.5, vector3( 0.8, 0.40, 0.25 ), vector3( 0.8, 0.40, 0.25 ),
			   0.7, vector3( 0.8, 0.40, 0.25 ), vector3( 0.8, 0.40, 0.25 ),
			   1.0, vector3( 1.0, 0.45, 0.45 ), vector3( 1.0, 0.45, 0.45 ),
			   "scale", 0.05,
			   "depth", 0.008,
			   "depth",
			   0.0, 1.0, 1.0,
			   1.0, 0.0, 0.0 ] )

s.transformEnd()
s.transformEnd()

granite2 = s.newPattern( "granite",
			 [ "color",
			   0.2, vector3( 0.0, 0.00, 0.00 ), vector3( 0.0, 0.00, 0.00 ),
			   0.7, vector3( 1.0, 1.00, 1.00 ), vector3( 1.0, 1.00, 1.00 ),
			   "value",
			   0.0, 0.0, 0.0,
			   1.0, 1.0, 1.0,
			   "scale", 0.03,
			   "depth", 0.0 ] )

granite = s.newPattern( "blend",
			[ "pattern", granite2,
			  "gradient",
			  0.0, granite2, granite2,
			  1.0, granite1, granite1 ] )

plastic = s.newMaterial( "standard",
			 [ "kc", vector3( 1.0, 1.0, 1.0 ),
			   "kd", 0.6,
			   "km", 0.03,
			   "kc", granite,
			   "displacement", granite ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "granite2.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -1, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
