#! /usr/bin/env python

from lightflowPM import *
from math import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 4.0, -5.0, 4.0 ), "color", vector3( 250.0, 250.0, 250.0 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3( -6.0, -3.0, -4.0 ), "color", vector3( 100.0, 0.0, 0.0 ) ] ) )


s.transformBegin( transform().rotationAroundZ( pi / 7 ) )
s.transformBegin( transform().rotationAroundX( pi / 6 ) )

marble1 = s.newPattern( "agate",
			[ "color",
			  0.00, vector3( 0.4, 0.40, 0.4 ), vector3( 0.4, 0.40, 0.4 ),
			  0.50, vector3( 1.0, 1.00, 1.0 ), vector3( 1.0, 1.00, 1.0 ),
			  "scale", 0.4 ] )

marble2 = s.newPattern( "multifractal",
			[ "color",
			  0.00, vector3( 0.8, 0.6, 0.5 ), vector3( 0.8, 0.6, 0.5 ),
			  0.50, vector3( 1.0, 1.0, 1.0 ), vector3( 1.0, 1.0, 1.0 ),
			  "scale", 0.4 ] )

marble = s.newPattern( "compose",
		       [ "patterns", marble2, marble1 ] )

s.transformEnd()
s.transformEnd()

plastic = s.newMaterial( "standard",
			 [ "kc", vector3( 1.0, 1.0, 1.0 ),
			   "kd", 0.5,
			   "kt", vector3( 0.1, 0.1, 0.1 ),
			   "km", 0.02,
			   "kc", marble ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "marble.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -1, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
