#! /usr/bin/env python

from lightflowPM import *
from math import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 4.0, -5.0, 4.0 ), "color", vector3( 250.0, 250.0, 250.0 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3( -6.0, -3.0, -4.0 ), "color", vector3( 100.0, 0.0, 0.0 ) ] ) )


s.transformBegin( transform().rotationAroundZ( pi / 7 ) )
s.transformBegin( transform().rotationAroundX( pi / 6 ) )

pattern1 = s.newPattern( "granite",
			 [ "color",
			   0.0, vector3( 0.9, 0.90, 1.00 ), vector3( 0.9, 0.90, 1.00 ),
			   0.5, vector3( 1.0, 1.00, 1.00 ), vector3( 1.0, 1.00, 1.00 ),
			   0.7, vector3( 1.0, 0.50, 0.55 ), vector3( 1.0, 0.50, 0.55 ),
			   0.8, vector3( 1.0, 0.40, 0.45 ), vector3( 1.0, 0.40, 0.45 ),
			   1.0, vector3( 1.0, 0.60, 0.65 ), vector3( 1.0, 0.60, 0.65 ),
			   "scale", 0.25,
			   "depth", 0.01 ] )

s.transformEnd()
s.transformEnd()

pattern2 = s.newPattern( "granite",
			 [ "color",
			   0.2, vector3( 0.0, 0.00, 0.00 ), vector3( 0.0, 0.00, 0.00 ),
			   0.7, vector3( 1.0, 1.00, 1.00 ), vector3( 1.0, 1.00, 1.00 ),
			   "value",
			   0.0, 0.0, 0.0,
			   1.0, 1.0, 1.0,
			   "scale", 0.15,
			   "depth", 0.01 ] )

mix = s.newPattern( "greater-than",
			[ "patterns", pattern1, pattern2 ] )

plastic = s.newMaterial( "standard",
			 [ "kc", vector3( 1.0, 1.0, 1.0 ),
			   "kd", 0.6,
			   "km", 0.03,
			   "kc", mix ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "misc1.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -1, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
