#! /usr/bin/env python

from lightflowPM import *
from math import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 4.0, -5.0, 4.0 ), "color", vector3( 200.0, 200.0, 200.0 ) ] ) )


s.transformBegin( transform().rotationAroundX( pi / 2.2 ) )
    
moon = s.newPattern( "moon", [] )

plastic = s.newMaterial( "standard",
			 [ "ka", vector3( 0.1, 0.1, 0.1 ),
			   "kc", vector3( 0.7, 0.7, 0.7 ),
			   "kd", 0.8,
			   "km", 0.1,
			   "kc", moon,
			   "ka", moon,
			   "displacement", moon ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )

s.materialEnd()

s.transformEnd()


saver = s.newImager( "tga-saver", [ "file", "moon.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -1, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
