#! /usr/bin/env python

from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "soft", [ "position", vector3( 5.0, -5.0, 4.0 ), "color", vector3( 300.0, 300.0, 300.0 ) ] ) )


bump = s.newPattern( "multifractal",
		     [ "basis", "ridged",
		       "scale", 0.5,
		       "depth", 0.3,
		       "turbulence.omega", 0.3, 0.6,
		       "turbulence.octaves", 6 ] )

plastic = s.newMaterial( "standard",
			 [ "ka", vector3( 0, 0, 0 ),
			   "kc", vector3( 1, 1, 1 ),
			   "kd", 0.55,
			   "km", 0.05,
			   "shinyness", 1.0,
			   "displacement", bump ] )


s.materialBegin( plastic )

patch = s.newObject( "patch",
		     [ "points",
		       vector3(-1.0, -1.0, 0.0), vector3(1.0, -1.0, 0.0),
		       vector3(-1.0,  1.0, 0.0), vector3(1.0,  1.0, 0.0) ] )

s.addObject( s.newObject( "surface-engine", [ "surfaces", patch, "tolerance", 0.02, 0.1, 0.2, "curvature", 0.0 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "multifractal2.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( 1, -2, 1.2 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
