# This file has been written by Matteo Sisti Sette (sistisette@iol.it)
# in order to have a fast preview of many patterns all at once.
# To add a new sample you should simply append another pattern at the
# end of the array named "patterns".

from lightflowPM import *
from math import *

blu=vector3(0, 0.6, 1)
red=vector3(1, 0, 0)
green=vector3(0, 1, 0.5)
violet=vector3(1, 0.2, 1)
orange=vector3(1, 0.6, 0.2)


white=vector3(1, 1, 1)

s=scene()

s.lightOn (s.newLight("directional", ["color", vector3(0.9, 0.9, 0.9), "direction", vector3(1.0, 1.0, -1.0)]))
s.lightOn (s.newLight("directional", ["color", vector3(0.2, 0.2, 0.2), "direction", vector3(-1.0, 1.0, 1.0)]))

scaleFactor=1.0/4
patterns=[]
patterns.append(s.newPattern("multifractal", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, red, white]))
patterns.append(s.newPattern("multifractal", ["basis", "ridged", "scale", scaleFactor, "color", 0.0, white, white, 1.0, green, white]))
patterns.append(s.newPattern("multifractal", ["basis", "eroded", "scale", scaleFactor, "color", 0.0, white, white, 1.0, blu, white]))
patterns.append(s.newPattern("multifractal", ["basis", "crater", "scale", scaleFactor, "color", 0.0, white, white, 1.0, violet, white]))
patterns.append(s.newPattern("multifractal", ["basis", "power", "scale", scaleFactor, "color", 0.0, white, white, 1.0, orange, white]))
patterns.append(s.newPattern("multifractal", ["basis", "exp", "scale", scaleFactor, "color", 0.0, white, white, 1.0, red, white]))
patterns.append(s.newPattern("multifractal", ["basis", "log", "scale", scaleFactor, "color", 0.0, white, white, 1.0, green, white]))
patterns.append(s.newPattern("multifractal", ["basis", "sin", "scale", scaleFactor, "color", 0.0, white, white, 1.0, blu, white]))
patterns.append(s.newPattern("multifractal", ["basis", "cos", "scale", scaleFactor, "color", 0.0, white, white, 1.0, violet, white]))
patterns.append(s.newPattern("agate", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, orange, white]))
patterns.append(s.newPattern("blotches", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, green, white]))
patterns.append(s.newPattern("bubbles", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, blu, white]))
patterns.append(s.newPattern("crackle", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, violet, white]))
patterns.append(s.newPattern("dents", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, orange, white]))
patterns.append(s.newPattern("granite", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, red, white]))
patterns.append(s.newPattern("marble", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, green, white]))
patterns.append(s.newPattern("pits", ["scale", scaleFactor, "color", blu]))
patterns.append(s.newPattern("scales", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, orange, white]))
patterns.append(s.newPattern("shingles", ["scale", scaleFactor, "color", 0.0, white, white, 1.0, red, white]))

# patterns.append( ...add your pattern here... )

trial=[]

for i in patterns:
	trial.append(s.newMaterial("diffuse", ["ka", vector3(0, 0, 0), "kr", vector3(1, 1, 1), "kr", i, "shadowing", 0.0]))

L=int(sqrt(len(trial)))
R=len(trial)/L
if R*L < len(trial) :
   R = R+1
for i in range(len(trial)):
	s.materialBegin(trial[i])
	s.transformBegin(transform().translation(vector3(2.0*(i%L)/L-(L-1.0)/L, 0, (R-1.0)/L - (2.0*int(i/L))/L)))
	s.addObject(s.newObject("sphere", ["radius", 1.0/L]))
	s.transformEnd()
	s.materialEnd()



saver=s.newImager("tga-saver", ["file", "patterns.tga"])

s.imagerBegin(saver)

camera=s.newCamera ("pinhole", ["eye", vector3(0.0, -4, 0.0), "aim", vector3(0, 0, 0)])

s.imagerEnd()


s.render(camera, 300, 300)
