#! /usr/bin/env python

from lightflowPM import *
from math import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 4.0, -5.0, 4.0 ), "color", vector3( 250.0, 250.0, 250.0 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3( -6.0, -3.0, -4.0 ), "color", vector3( 80.0, 0.0, 0.0 ) ] ) )


wood = s.newPattern( "oldwood",
		     [ "vein-color", vector3( 0.8, 0.6, 0.40 ),
		       "node-color", vector3( 0.3, 0.2, 0.15 ),
		       "darkening-amount", 0.2,
		       "scale", 0.2,
		       "depth", 0.002 ] )

plastic = s.newMaterial( "standard",
			 [ "kc", vector3( 1.0, 0.85, 0.70 ),
			   "kd", 0.7,
			   "km", 0.1,
			   "kc", wood,
			   "displacement", wood ] )

s.materialBegin( plastic )

s.addObject( s.newObject( "sphere", [ "radius", 1.0 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "wood2.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( -1, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
