#! /usr/bin/env python

from math import *
from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( -8.0, 2.0, 4.0 ), "color", vector3( 400, 400, 400 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3(  6.0, -8.0, 7.0 ), "color", vector3( 400, 400, 400 ) ] ) )


ellipsoid = s.newPattern( "directional-displacement",
			  [ "value",
			    0.0, 0.02, 0.02,
			    1.0, 0.20, 0.20,
			    "color",
			    0.0, vector3( 1.0, 0.0, 0.0 ), vector3( 1.0, 0.0, 0.0 ),
			    0.5, vector3( 0.0, 1.0, 0.0 ), vector3( 0.0, 1.0, 0.0 ),
			    1.0, vector3( 0.0, 0.0, 1.0 ), vector3( 0.0, 0.0, 1.0 ),
			    "scale", 0.2,
			    "turbulence.amount", 0.2,
			    "turbulence.frequency", 10.0 ] )

anisotropic = s.newMaterial( "generic",
			     [ "ka", vector3( 0, 0, 0 ),
			       "kdr", vector3( 0.8, 0.8, 0.8 ),
			       "ksr", vector3( 1.0, 1.0, 1.0 ),
			       "ksr", ellipsoid,
			       "km", 0.5,
			       "shinyness", 0.0 ] )


s.materialBegin( anisotropic )

s.addObject( s.newObject( "blob",
			  [ "threshold", 0.5,
			    "blob", vector3( -0.7,  0.0,  0.30), 0.8, 1.1,
			    "blob", vector3(  0.7,  0.0,  0.30), 0.8, 1.1,
			    "blob", vector3(  0.0,  0.0, -0.58), 0.8, 1.1 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "anisotropic5.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( 0, -4, 0 ), "aim", vector3( 0, 0, 0 ), "fov", 0.75 ] )

s.imagerEnd()

s.render( camera, 300, 300 )
