#! /usr/bin/env python

from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( -8.0, 2.0, 4.0 ), "color", vector3( 400, 400, 400 ) ] ) )
s.lightOn( s.newLight( "point", [ "position", vector3(  6.0, -8.0, 7.0 ), "color", vector3( 400, 400, 400 ) ] ) )


anisotropic = s.newPattern( "directional-displacement",
			    [ "value",
			      0.0, 0.02, 0.02,
			      1.0, 0.20, 0.20,
			      "color",
			      0.0, vector3( 1.0, 0.2, 0.2 ), vector3( 1.0, 0.2, 0.2 ),
			      0.5, vector3( 0.2, 1.0, 0.2 ), vector3( 0.2, 1.0, 0.2 ),
			      1.0, vector3( 0.2, 0.2, 1.0 ), vector3( 0.2, 0.2, 1.0 ),
			      "scale", 0.15,
			      "turbulence.amount", 0.2,
			      "turbulence.frequency", 10.0 ] )

anisotropic2 = s.newPattern( "directional-displacement",
			     [ "value",
			       0.0, 0.02, 0.02,
			       1.0, 0.20, 0.20,
			       "color",
			       0.0, vector3( 1.0, 0.8, 0.8 ), vector3( 1.0, 0.8, 0.8 ),
			       0.5, vector3( 0.8, 1.0, 0.8 ), vector3( 0.8, 1.0, 0.8 ),
			       1.0, vector3( 0.8, 0.8, 1.0 ), vector3( 0.8, 0.8, 1.0 ),
			       "scale", 0.15,
			       "turbulence.amount", 0.2,
			       "turbulence.frequency", 10.0 ] )

glass = s.newMaterial( "generic",
		       [ "fresnel", 1,
			 "IOR", 1.57,
			 "kdr", vector3( 0, 0, 0 ),
 			 "kdt", vector3( 0, 0, 0 ),
			 "ksr", vector3( 0.8, 0.9, 1 ), vector3( 1, 0.4, 1 ),
			 "ksr", anisotropic,
			 "kst", vector3( 1, 1, 1 ),
			 "kst", anisotropic2,
			 "kr", vector3( 0.8, 0.9, 1 ),
			 "kr", anisotropic,
			 "kt", vector3( 1, 1, 1 ),
			 "km", 0.1,
			 "shinyness", 0.85 ] )

trnswash = s.newMaterial( "generic",
                          [ "kdr", vector3( 0.9, 0.9, 0.9 ),
                            "ksr", vector3( 0.5, 0.5, 0.5 ),
                            "km", 0.07,
                            "shinyness", 0.0,
                            "visibility", 1 ] )


s.materialBegin( glass )

s.addObject( s.newObject( "blob",
			  [ "threshold", 0.5,
			    "blob", vector3( -0.7,  0.0,  0.30), 0.8, 1.1,
			    "blob", vector3(  0.7,  0.0,  0.30), 0.8, 1.1,
			    "blob", vector3(  0.0,  0.0, -0.58), 0.8, 1.1 ] ) )

s.materialEnd()

s.materialBegin( trnswash )

s.addObject( s.newObject( "box",
			  [ "position", vector3( -20, -20, -20 ), vector3( 20, 20, 20 ) ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "anisotropic6.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( 0, -4, 0 ), "aim", vector3( 0, 0, 0 ), "fov", 0.75 ] )

s.imagerEnd()

s.render( camera, 400, 400 )
