#! /usr/bin/env python

from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 5.0, -5.0, 4.0 ), "color", vector3( 3.0, 3.0, 3.0 ), "decay", 0.0 ] ) )

sky = s.newMaterial( "matte",
			 [ "kc", vector3( 0.3, 0.5, 0.9 ) ] )

plastic = s.newMaterial( "standard",
			 [ "kc", vector3( 1, 1, 1 ),
			   "kr", vector3( 0.5, 0.5, 0.5 ),
			   "kd", 0.5, "km", 0.1 ] )

bump = s.newPattern( "blotches",
		     [ "depth",
		       0.0, 0.0, 0.0,
		       1.0, 1.0, 1.0,
		       "scale", 0.3,
		       "depth", 0.40,
		       "turbulence.octaves", 2 ] )

cartoon = s.newMaterial( "cartoon", [ "line-width", 0.3, "displacement", bump ] )


s.materialBegin( sky )

s.addObject( s.newObject( "sphere", [ "radius", 100.0 ] ) )

s.materialEnd()

s.materialBegin( cartoon )

sphere = s.newObject( "sphere",
		     [ "radius", 1.0 ] )

s.addObject( s.newObject( "surface-engine",
			  [ "surfaces", sphere,
			    "tolerance", 0.01, 0.1, 0.05,
			    "caching", 8192 ] ) )

s.materialEnd()


s.transformBegin( transform().translation( vector3( 0, 0, -1.3 ) ) )

s.materialBegin( plastic )

s.addObject( s.newObject( "disc", [ "radius", 100.0 ] ) )

s.materialEnd()

s.transformEnd()


saver = s.newImager( "tga-saver", [ "file", "cartoon.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( 0, -4, 2 ), "aim", vector3( 0, 0, -0.2 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
