#! /usr/bin/env python

from lightflowPM import *

s = scene()

s.lightOn( s.newLight( "point", [ "position", vector3( 5.0, -5.0, 4.0 ), "color", vector3( 300.0, 300.0, 300.0 ) ] ) )


plastic = s.newMaterial( "standard", [ "ka", vector3( 0, 0, 0.5 ), "kc", vector3( 1, 0.5, 0.5 ), "kd", 0.5, "km", 0.1 ] )

s.materialBegin( plastic )

s.transformBegin( transform().translation( vector3( -0.4, 0, 0 ) ) )
		  
sph1 = s.newObject( "sphere", [ "radius", 1.0 ] )

s.transformEnd()

s.transformBegin( transform().translation( vector3( 0.2, 0, 0 ) ) )

sph2 = s.newObject( "sphere", [ "radius", 0.6 ] )

s.transformEnd()

s.transformBegin( transform().translation( vector3( 0.4, 0, 0 ) ) )

sph3 = s.newObject( "sphere", [ "radius", 1.0 ] )

s.transformEnd()

s.transformBegin( transform().translation( vector3( -0.4, 0, 0 ) ) )

sph4 = s.newObject( "sphere", [ "radius", 0.6 ] )

s.transformEnd()

csg1 = s.newObject( "solid",
		    [ "type", "difference",
		      "solids", sph1, sph2 ] )

csg2 = s.newObject( "solid",
		    [ "type", "union",
		      "solids", sph3, sph4 ] )

s.addObject( s.newObject( "solid",
			  [ "type", "intersection",
			    "solids", csg1, csg2 ] ) )

s.materialEnd()


saver = s.newImager( "tga-saver", [ "file", "csg.tga" ] )

s.imagerBegin( saver )

camera = s.newCamera( "pinhole", [ "eye", vector3( 2, -4, 0 ), "aim", vector3( 0, 0, 0 ) ] )

s.imagerEnd()

s.render( camera, 300, 300 )
