// ============================================================================ //
// Lightflow Rendering Interface                                                //
// ============================================================================ //
// LfArgList.h                                                                  //
// ============================================================================ //
//                                                                              //
// The contents of this file are subject to the Lightflow Rendering Interface   //
// License (the License); you may not use this file except in compliance with   //
// the License. You may obtain a copy of the License by sending an email at     //
// jp@lightflowtech.com with subject LRI-LICENSE.                               //
//                                                                              //
// ============================================================================ //
// Copyright (c) 1995-2000 by Jacopo Pantaleoni. All rights reserved.           //
// ============================================================================ //

#ifndef _LfArgList_H
#define _LfArgList_H 1

#include <Lightflow/LfArgListBlock.h>


class LfAPI_CS LfArgList
{
private:
	LfInt   Size;
	LfInt   MinSize;

	LfArgListBlock *Block;

public:
	LfArgList  (LfInt size = 0, LfInt minsize = 0);
	LfArgList  (const LfArgList& array );
	~LfArgList (void);

	LfArgType& operator [] (LfInt i);

	void             Add (const LfArgType& n);
	const LfArgType& Get (LfInt i) const;
	void             Set (LfInt i, const LfArgType& n);

	void    SetSize    (LfInt size);
	LfInt   GetSize    (void) const { return Size; }

	void    Reset      (void);
	void    Compactify (void);
};

inline LfAPI_CS LfArgList& operator<< (LfArgList& list, LfArgType e);

// ---------------------------------------- IMPLEMENTATION ---------------------------------------- //

inline LfAPI_CS LfArgList& operator<< (LfArgList& list, LfArgType e)
{
	list.Add( e );
	return list;
}


#endif
