// ============================================================================ //
// Lightflow Rendering Interface                                                //
// ============================================================================ //
// LfError.h                                                                    //
// ============================================================================ //
//                                                                              //
// The contents of this file are subject to the Lightflow Rendering Interface   //
// License (the License); you may not use this file except in compliance with   //
// the License. You may obtain a copy of the License by sending an email at     //
// jp@lightflowtech.com with subject LRI-LICENSE.                               //
//                                                                              //
// ============================================================================ //
// Copyright (c) 1995-2000 by Jacopo Pantaleoni. All rights reserved.           //
// ============================================================================ //

#ifndef _LfError_H
#define _LfError_H 1

#include <Lightflow/LfBasicTypes.h>


class LfAPI_CS LfError
{
private:
	LfString String;
	LfString Location;
	LfInt    Level;

public:
	LfError(const LfString string, const LfString location, LfInt level);
	LfError(const LfError& error);
	virtual ~LfError();

	const LfString GetString   (void) const { return String; }
	const LfString GetLocation (void) const { return Location;  }
	LfInt          GetLevel    (void) const { return Level;  }
};


#endif
