// ============================================================================ //
// Lightflow Rendering Interface                                                //
// ============================================================================ //
// LfLocalSceneProxy.h                                                          //
// ============================================================================ //
//                                                                              //
// The contents of this file are subject to the Lightflow Rendering Interface   //
// License (the License); you may not use this file except in compliance with   //
// the License. You may obtain a copy of the License by sending an email at     //
// jp@lightflowtech.com with subject LRI-LICENSE.                               //
//                                                                              //
// ============================================================================ //
// Copyright (c) 1995-2000 by Jacopo Pantaleoni. All rights reserved.           //
// ============================================================================ //

#ifndef _LfLocalSceneProxy_H
#define _LfLocalSceneProxy_H 1

#include <Lightflow/LfSceneProxy.h>


class LfAPI_CS LfLocalSceneProxy : public LfSceneProxy
{
private:
	LfScene* Scene;

public:
	LfLocalSceneProxy(LfInt texturememory = 10 * 1024);
	virtual ~LfLocalSceneProxy();


// - Entity Constructors and Services ------------------------------------------------------------------------ //
	LfInt  NewCamera        (const LfString type, const LfArgList& arglist);
	LfInt  NewImager        (const LfString type, const LfArgList& arglist);
	LfInt  NewInterface     (const LfString type, const LfArgList& arglist);
	LfInt  NewInterior      (const LfString type, const LfArgList& arglist);
	LfInt  NewLight         (const LfString type, const LfArgList& arglist);
	LfInt  NewMaterial      (const LfString type, const LfArgList& arglist);
	LfInt  NewObject        (const LfString type, const LfArgList& arglist);
	LfInt  NewPattern       (const LfString type, const LfArgList& arglist);
	LfInt  NewTexture       (const LfString name);
	LfInt  NewTrimmer       (const LfString type, const LfArgList& arglist);

	void   ImagerBegin      (LfInt index);
	void   ImagerEnd        (void);

	void   InteriorBegin    (LfInt index);
	void   InteriorEnd      (void);

	void   LightOn          (LfInt index);
	void   LightOff         (LfInt index);
	void   LightBegin       (void);
	void   LightEnd         (void);

	void   MaterialBegin    (LfInt index);
	void   MaterialEnd      (void);

	void   AddObject        (LfInt index);
// ----------------------------------------------------------------------------------------------------------- //

// - Transform Operators ------------------------------------------------------------------------------------- //
	void   TransformBegin   (LfTransform t);
	void   TransformEnd     (void);
// ----------------------------------------------------------------------------------------------------------- //

// - Rendering Operators ------------------------------------------------------------------------------------- //
	void   Radiosity (void);
	void   Render    (LfInt camera, LfInt w=320, LfInt h=240,
					  LfFloat c1=0, LfFloat r1=0, LfFloat c2=1, LfFloat r2=1);
// ----------------------------------------------------------------------------------------------------------- //
};


#endif
